## GtkFileSelection

GtkFileSelection — Prompt the user for a file or directory name

## Functions

GtkWidget * | gtk_file_selection_new ()
void | gtk_file_selection_complete ()
void | gtk_file_selection_show_fileop_buttons ()
void | gtk_file_selection_hide_fileop_buttons ()
void | gtk_file_selection_set_select_multiple ()
gboolean | gtk_file_selection_get_select_multiple ()

## Properties

gchar * | filename | Read / Write
gboolean | select-multiple | Read / Write
gboolean | show-fileops | Read / Write

## Types and Values

struct | GtkFileSelection
#define | gtk_file_selection_set_filename
#define | gtk_file_selection_get_filename
#define | gtk_file_selection_get_selections

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkBin
                            ╰── GtkWindow
                                ╰── GtkDialog
                                    ╰── GtkFileSelection

## Implemented Interfaces

GtkFileSelection implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkFileSelection has been superseded by the newer GtkFileChooser family of widgets.

GtkFileSelection should be used to retrieve file or directory names from the user. It will create a new dialog window containing a directory list, and a file list corresponding to the current working directory. The filesystem can be navigated using the directory list or the drop-down history menu. Alternatively, the TAB key can be used to navigate using filename completion - common in text based editors such as emacs and jed.

File selection dialogs are created with a call to `gtk_file_selection_new()`.

The default filename can be set using `gtk_file_selection_set_filename()` and the selected filename retrieved using `gtk_file_selection_get_filename()`.

Use `gtk_file_selection_complete()` to display files and directories that match a given pattern. This can be used for example, to show only *.txt files, or only files beginning with gtk*.

Simple file operations; create directory, delete file, and rename file, are available from buttons at the top of the dialog. These can be hidden using `gtk_file_selection_hide_fileop_buttons()` and shown again using `gtk_file_selection_show_fileop_buttons()`.

Example 64. Getting a filename from the user.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27

    /* The file selection widget and the string to store the chosen filename */
    void store_filename (GtkWidget *widget, gpointer user_data) {
       GtkWidget *file_selector = GTK_WIDGET (user_data);
       const gchar *selected_filename;
       selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION (file_selector));
       g_print ("Selected filename: %s\n", selected_filename);
    }
    void create_file_selection (void) {
       GtkWidget *file_selector;
       /* Create the selector */
       file_selector = gtk_file_selection_new ("Please select a file for editing.");
       g_signal_connect (GTK_FILE_SELECTION (file_selector)->ok_button,
                         "clicked",
                         G_CALLBACK (store_filename),
                         file_selector);
       /* Ensure that the dialog box is destroyed when the user clicks a button. */
       g_signal_connect_swapped (GTK_FILE_SELECTION (file_selector)->ok_button,
                                 "clicked",
                                 G_CALLBACK (gtk_widget_destroy),
                                 file_selector);
       g_signal_connect_swapped (GTK_FILE_SELECTION (file_selector)->cancel_button,
                                 "clicked",
                                 G_CALLBACK (gtk_widget_destroy),
                                 file_selector);
       /* Display that dialog */
       gtk_widget_show (file_selector);
    }

## Functions

### gtk_file_selection_new ()

    GtkWidget *
    gtk_file_selection_new (const gchar *title);

`gtk_file_selection_new` is deprecated and should not be used in newly-written code.

Use `gtk_file_chooser_dialog_new()` instead

Creates a new file selection dialog box. By default it will contain a GtkTreeView of the application's current working directory, and a file listing. Operation buttons that allow the user to create a directory, delete files and rename files, are also present.

#### Parameters

title | a message that will be placed in the file requestor's titlebar. |

#### Returns

the new file selection.

### gtk_file_selection_complete ()

    void
    gtk_file_selection_complete (GtkFileSelection *filesel,
                                 const gchar *pattern);

`gtk_file_selection_complete` is deprecated and should not be used in newly-written code.

Will attempt to match `pattern` to a valid filenames or subdirectories in the current directory. If a match can be made, the matched filename will appear in the text entry field of the file selection dialog. If a partial match can be made, the "Files" list will contain those file names which have been partially matched, and the "Folders" list those directories which have been partially matched.

#### Parameters

filesel | a GtkFileSelection. |
pattern | a string of characters which may or may not match any filenames in the current directory. |

### gtk_file_selection_show_fileop_buttons ()

    void
    gtk_file_selection_show_fileop_buttons
                                   (GtkFileSelection *filesel);

`gtk_file_selection_show_fileop_buttons` is deprecated and should not be used in newly-written code.

Shows the file operation buttons, if they have previously been hidden. The rest of the widgets in the dialog will be resized accordingly.

#### Parameters

filesel | a GtkFileSelection. |

### gtk_file_selection_hide_fileop_buttons ()

    void
    gtk_file_selection_hide_fileop_buttons
                                   (GtkFileSelection *filesel);

`gtk_file_selection_hide_fileop_buttons` is deprecated and should not be used in newly-written code.

Hides the file operation buttons that normally appear at the top of the dialog. Useful if you wish to create a custom file selector, based on GtkFileSelection.

#### Parameters

filesel | a GtkFileSelection. |

### gtk_file_selection_set_select_multiple ()

    void
    gtk_file_selection_set_select_multiple
                                   (GtkFileSelection *filesel,
                                    gboolean select_multiple);

`gtk_file_selection_set_select_multiple` is deprecated and should not be used in newly-written code.

Sets whether the user is allowed to select multiple files in the file list. Use `gtk_file_selection_get_selections()` to get the list of selected files.

#### Parameters

filesel | a GtkFileSelection |
select_multiple | whether or not the user is allowed to select multiple files in the file list. |

### gtk_file_selection_get_select_multiple ()

    gboolean
    gtk_file_selection_get_select_multiple
                                   (GtkFileSelection *filesel);

`gtk_file_selection_get_select_multiple` is deprecated and should not be used in newly-written code.

Determines whether or not the user is allowed to select multiple files in the file list. See `gtk_file_selection_set_select_multiple()`.

#### Parameters

filesel | a GtkFileSelection |

#### Returns

`TRUE` if the user is allowed to select multiple files in the file list

## Types and Values

### struct GtkFileSelection

    struct GtkFileSelection {
      GtkWidget *dir_list;
      GtkWidget *file_list;
      GtkWidget *selection_entry;
      GtkWidget *selection_text;
      GtkWidget *main_vbox;
      GtkWidget *ok_button;
      GtkWidget *cancel_button;
      GtkWidget *help_button;
      GtkWidget *history_pulldown;
      GtkWidget *history_menu;
      GList     *history_list;
      GtkWidget *fileop_dialog;
      GtkWidget *fileop_entry;
      gchar     *fileop_file;
      gpointer   cmpl_state;

      GtkWidget *fileop_c_dir;
      GtkWidget *fileop_del_file;
      GtkWidget *fileop_ren_file;

      GtkWidget *button_area;
      GtkWidget *action_area;
    };

`GtkFileSelection` is deprecated and should not be used in newly-written code.

The GtkFileSelection struct contains the following GtkWidget fields:

#### Members

GtkWidget *`dir_list`; |  |
GtkWidget *`file_list`; |  |
GtkWidget *`selection_entry`; |  |
GtkWidget *`selection_text`; |  |
GtkWidget *`main_vbox`; |  |
GtkWidget *`ok_button`; |  |
GtkWidget *`cancel_button`; | the two main buttons that signals should be connected to in order to perform an action when the user hits either OK or Cancel. |
GtkWidget *`help_button`; |  |
GtkWidget *`history_pulldown`; | the GtkOptionMenu used to create the drop-down directory history. |
GtkWidget *`history_menu`; |  |
GList *`history_list`; |  |
GtkWidget *`fileop_dialog`; | the dialog box used to display the GtkFileSelection. It can be customized by adding/removing widgets from it using the standard GtkDialog functions. |
GtkWidget *`fileop_entry`; |  |
gchar *`fileop_file`; |  |
gpointer `cmpl_state`; |  |
GtkWidget *`fileop_c_dir`; |  |
GtkWidget *`fileop_del_file`; |  |
GtkWidget *`fileop_ren_file`; | the buttons that appear at the top of the file selection dialog. These "operation buttons" can be hidden and redisplayed with `gtk_file_selection_hide_fileop_buttons()` and `gtk_file_selection_show_fileop_buttons()` respectively. |
GtkWidget *`button_area`; |  |
GtkWidget *`action_area`; |  |

### gtk_file_selection_set_filename

    #define gtk_file_selection_set_filename gtk_file_selection_set_filename_utf8

`gtk_file_selection_set_filename` is deprecated and should not be used in newly-written code.

Sets a default path for the file requestor. If `filename` includes a directory path, then the requestor will open with that path as its current working directory.

This has the consequence that in order to open the requestor with a working directory and an empty filename, `filename` must have a trailing directory separator.

The encoding of `filename` is preferred GLib file name encoding, which may not be UTF-8. See `g_filename_from_utf8()`.

#### Parameters

filesel | a GtkFileSelection. |
filename | a string to set as the default file name. |

### gtk_file_selection_get_filename

    #define gtk_file_selection_get_filename gtk_file_selection_get_filename_utf8

`gtk_file_selection_get_filename` is deprecated and should not be used in newly-written code.

This function returns the selected filename in the GLib file name encoding. To convert to UTF-8, call `g_filename_to_utf8()`. The returned string points to a statically allocated buffer and should be copied if you plan to keep it around.

If no file is selected then the selected directory path is returned.

#### Returns

currently-selected filename in the on-disk encoding.

### gtk_file_selection_get_selections

    #define gtk_file_selection_get_selections gtk_file_selection_get_selections_utf8

`gtk_file_selection_get_selections` is deprecated and should not be used in newly-written code.

Retrieves the list of file selections the user has made in the dialog box. This function is intended for use when the user can select multiple files in the file list.

The filenames are in the GLib file name encoding. To convert to UTF-8, call `g_filename_to_utf8()` on each string.

#### Returns

a newly-allocated `NULL`-terminated array of strings. Use `g_strfreev()` to free it.

## Property Details

### The `“filename”` property

      “filename”                 gchar *

The currently selected filename.

Flags: Read / Write

Default value: NULL

### The `“select-multiple”` property

      “select-multiple”          gboolean

Whether to allow multiple files to be selected.

Flags: Read / Write

Default value: FALSE

### The `“show-fileops”` property

      “show-fileops”             gboolean

Whether buttons for creating/manipulating files should be displayed.

Flags: Read / Write

Default value: TRUE

## See Also

GtkDialog | Add your own widgets into the GtkFileSelection.